#include <cstdio>
#include <queue>
#include <algorithm>
#include <cstring>
using namespace std;

#define INF 1000000005
#define MAXN 150000
#define MAXK 50000

int N, K, root, t, p;
int color[MAXN], eAdj[MAXN], depth[MAXN], deep[MAXK], cSize[MAXK], ePrev[MAXN], elast[MAXN];
int anc[17][MAXN];
int *cList[MAXN];

int lca (int a, int b)
{
	if (depth[a] < depth[b])
		swap(a, b);

	for (int i = 0; 1 << i <= depth[a] - depth[b]; i++)
		if ((depth[a] - depth[b] & 1 << i) != 0)
			a = anc[i][a];

	if (a == b)
		return a;

	int start = 0;
	while (1 << (start + 1) <= depth[a])
		start++;

	for (int i = start; i >= 0; i--)
		if (anc[i][a] != anc[i][b])
			a = anc[i][a], b = anc[i][b];

	return anc[0][a];
}

int dist (int a, int b)
{
    return depth[a] + depth[b] - 2 * depth[lca (a, b)];
}

int solve (int par)
{
    int ans = 0;
    for (int i = 0; i < cSize[par]; i++)
        ans = max (ans, dist (deep[par], cList[par][i]));
    return ans;
}

void prepare()
{
	for (int i = 0; i < K; i++)
        cList[i] = new int[cSize[i]];

	memset(cSize, 0, sizeof cSize);
	for (int i = 0; i < N; i++)
	{
		cList[color[i]][cSize[color[i]]++] = i;
		depth[i] = INF;
	}

	queue<int> qu;
	qu.push(root);
	depth[root] = 0;

	while (!qu.empty())
    {
		int top = qu.front(); qu.pop();
		int par = color[top];

        if (depth[top] > depth[deep[par]] || deep[par] == -1)
            deep[par] = top;

        for (int i = elast[top]; i != -1; i = ePrev[i])
            if (depth[top] + 1 < depth[eAdj[i]])
            {
                depth[eAdj[i]] = depth[top] + 1;
				qu.push(eAdj[i]);
            }
    }

    for (int k = 0; 2 << k < N; k++)
        for (int i = 0; i < N; i++)
            anc[k + 1][i] = anc[k][i] == -1 ? -1 : anc[k][anc[k][i]];
}

void read()
{
	scanf("%d %d\n", &N, &K);
	for (int i = 0, e = 0; i < N; i++)
    {
		 scanf("%d %d\n", &p, &color[i]);
		 color[i]--;
		 anc[0][i] = --p;

		 cSize[color[i]]++;

        if (p == -1)
			root = i;
		else
        {
            eAdj[e] = i;
            ePrev[e] = elast[p];
            elast[p] = e++;
        }
	}
}

void init()
{
	memset(color, 0, sizeof color);
	memset(eAdj, 0, sizeof eAdj);
	memset(elast, -1, sizeof elast);
	memset(ePrev, 0, sizeof ePrev);
	memset(deep, -1, sizeof deep);
	memset(cSize, 0, sizeof cSize);
	memset(anc, 0, sizeof anc);
	memset(cList, 0, sizeof cList);
}

int main()
{
	scanf("%d\n", &t);
	while(t--)
	{
		init();
		read();
		prepare();
		for (int i = 0; i < K; i++)
			printf("%d\n", solve(i));
	}

	return 0;
}
