#pragma warning(disable: 4786)
#include <iostream>
#include <sstream>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <algorithm>
using namespace std;
class Library {
private:
string m_strLibName;
unsigned m_uNumRacks;
unsigned m_uCapacity;
multimap<int,string> libRacks;
public:
  Library(const string& strFileName){
	  ifstream iStream(strFileName.data());
    if(iStream.good()) {
      iStream>>m_uNumRacks>>m_uCapacity;
      set<string> books;
      copy(istream_iterator < string > (iStream), istream_iterator < string > (), inserter(books, books.begin()) );
      if(books.size()>m_uNumRacks*m_uCapacity){
        throw "DATA_ERROR";
      }
      set<string>::iterator it=books.begin();
      int rack=0;
      int bookNum=0;
      while(it != books.end()){
        if(bookNum==m_uCapacity) {
          rack++;
          bookNum=0;
        }
        libRacks.insert(make_pair(rack,string(*it)));
        bookNum++; it++;
      }
    } else throw "FILE_ERROR";
  }
#ifdef _DEBUG
  void output(){
	  multimap<int,string>::iterator it=libRacks.begin();
	  while(it!=libRacks.end()){
		  int rackNum=(*it).first;
		  string ID=(*it).second;
		  cout<<rackNum+1<<"=>"<<ID<<endl;
		  it++;
	  }
  }
#endif
	void makeAndShowIndex(){
    unsigned max_len=0;
    for(unsigned rackNum=0;rackNum<m_uNumRacks; rackNum++){
		  pair<multimap<int,string>::iterator,multimap<int,string>::iterator> ret;
		  ret = libRacks.equal_range(rackNum);
		  if(ret.first!=libRacks.end()){
			  string firstIndex=(*ret.first).second;
			  multimap<int,string>::iterator it=ret.second;
        string nextRackFirstIndex;
        if(it!=libRacks.end()){
			    nextRackFirstIndex=(*it).second;
        }
			  it--;
			  string secondIndex=(*it).second;
			  string inters;
			  string inters2;
			  set_intersection(firstIndex.begin(),firstIndex.end(),secondIndex.begin(),secondIndex.end(),back_inserter(inters));
			  set_intersection(secondIndex.begin(),secondIndex.end(),nextRackFirstIndex.begin(),nextRackFirstIndex.end(),back_inserter(inters2));
        max_len=(max_len<(inters.length()+1))?inters.length()+1:max_len;
        max_len=(max_len<(inters2.length()+1))?inters2.length()+1:max_len;
        string diff1=firstIndex.substr(0,max_len);
			  string diff2=secondIndex.substr(0,max_len);;
			  cout<<rackNum+1<<" ";
#ifdef _DEBUG
        cout<<"=>"<<firstIndex<<"::"<<secondIndex<<" ";
#endif
        cout<<diff1<<" "<< diff2 <<endl;
		  }
    }
  }
};


void main() {
  try{
	Library oLib("K.in");
#ifdef _DEBUG
  cout<<"__________________"<<endl;
  oLib.output();
  cout<<"__________________"<<endl;
  cout<<"makeIndex__________________"<<endl;
#endif
  oLib.makeAndShowIndex();
  }catch(char* err){
    cout<<err<<endl;
  }
}
